"
 COPYRIGHT (c) 1992 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

Object subclass:#Controller
       instanceVariableNames:'model view sensor manager'
       classVariableNames:''
       poolDictionaries:''
       category:'Interface-Support'
!

Controller comment:'
COPYRIGHT (c) 1992 by Claus Gittinger
              All Rights Reserved
'!

!Controller class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1992 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

version
"
$Header: /cvs/stx/stx/libview/Attic/Controll.st,v 1.5 1994-06-03 00:52:01 claus Exp $
"
!

documentation
"
    Controllers can be used to controll the user-interactions
    to a Model which is shown in a view. For very simple views,
    (and due to the evolution of Smalltalk/X) many view-classes have
    the controller function integrated.

    Instance variables:
        view        aView		the view I controll
        model       aModel		the model which is to be worked on
        sensor      aWindowSensor	a sensor, getting events
"
! !

!Controller methodsFor:'initialize / release'!

initialize
    "initialize the controller; subclasses should redefine
     this and include a super initialize for proper initialization."

    ^ self
!

release
    view controller:nil.
    view := nil.
    model := nil
! !

!Controller methodsFor:'accessing'!

view:aView
    "set my view"

    view notNil ifTrue:[
        model notNil ifTrue:[
            model removeDependent:view
        ]
    ].
    view := aView.
    model notNil ifTrue:[
        model addDependent:view
    ].
    sensor := WindowSensor new.
!

view
    "return my view"

    ^ view
!

model:aModel
    "set my model"

    model notNil ifTrue:[
        model removeDependent:view
    ].
    model := aModel.
    model notNil ifTrue:[model addDependent:view]
!

model
    "return my model"

    ^ view model
!

sensor:aSensor
    "set my sensor"

    sensor := aSensor
!

sensor 
    "return my sensor"

    ^ sensor
!

manager:aControlManager
    "set my manager"

    manager := aControlManager
!

manager
    "return my manager"

    ^ manager
! !

!Controller methodsFor:'event processing'!

process
    |any damage ev|

     any := true.
    [any] whileTrue:[
        any := false.
        damage := sensor nextDamage.
        [damage notNil] whileTrue:[
'controller processing expose' printNewline.
            view exposeX:(damage left) y:(damage top)
                   width:(damage width) height:(damage height).
            damage := sensor nextDamage.
            any := true
        ].
        ev := sensor nextEvent.
        [ev notNil] whileTrue:[
'controller processing event' printNewline.
            ev sendTo:view.
            ev := sensor nextEvent.
            any := true
        ].
    ]
! !
