"
 COPYRIGHT (c) 1993 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"

Object subclass:#WindowEvent
         instanceVariableNames:'view type arguments'
         classVariableNames:''
         poolDictionaries:''
         category:'Interface-Support'
!

!WindowEvent class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 1993 by Claus Gittinger
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.   This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
!

version
"
$Header: /cvs/stx/stx/libview/WindowEvent.st,v 1.5 1994-06-03 00:54:00 claus Exp $
"
!

documentation
"
    Instances of WindowEvent are created for every event coming from
    the graphics device, to be handled by a windowGroup. Usually, they
    are queued by a sensor, and processed in some ebent loop in the window group.
"
! !

!WindowEvent class methodsFor:'instance creation'!

for:aView type:aSymbol arguments:argArray
    "create and return a new windowEvent for sending
     aSymbol-message with arguments to aView"

    ^ (self new) for:aView type:aSymbol arguments:argArray
!

damageFor:aView rectangle:aRectangle
    "create and return a new damage Event for aRectangle
     in aView"

    ^ (self new) for:aView type:#damage arguments:aRectangle

! !

!WindowEvent methodsFor:'accessing'!

view
    "return the view, for which the event is for"

    ^ view
!

type
    "return the type of the event"

    ^ type
!

arguments
    "return the arguments of the event"

    ^ arguments
!

arguments:anArray
    "set the arguments"

    arguments := anArray
!

rectangle
    "return the damage rectangle"

    ^ arguments "consider this a kludge"
! !

!WindowEvent methodsFor:'sending'!

sendEvent
    "forward the event represented by the receiver to the view
     or delegate"

    |delegate selector|

    type == #keyPress:x:y: ifTrue:[
        view device sendKeyPress:(arguments at:1)
                               x:(arguments at:2)
                               y:(arguments at:3)
                              to:view 
    ] ifFalse:[
        delegate := view delegate.
        delegate notNil ifTrue:[
            "what a kludge - sending to delegate needs another
             selector and an additional argument.
             have to edit the selector ..."

            (type endsWith:':') ifTrue:[
                selector := (type , 'view:') asSymbol.
            ] ifFalse:[
                selector := (type , 'View:') asSymbol.
            ].
            arguments isNil ifTrue:[
                delegate perform:selector with:view
            ] ifFalse:[
                delegate perform:selector withArguments:(arguments copyWith:view)
            ]
        ] ifFalse:[
            view perform:type withArguments:arguments
        ]
    ]
! !

!WindowEvent methodsFor:'private accessing'!

for:aView type:aSymbol arguments:argArray
    "set the instances of the window event"

    view := aView.
    type := aSymbol.
    arguments := argArray
! !
